SystemOrganization addCategory: #'Webtalk-Libraries-Core'!

Object subclass: #WTJQueryThemesManager
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Webtalk-Libraries-Core'!

!WTJQueryThemesManager class methodsFor: 'as yet unclassified' stamp: 'GastonDallOglio 3/16/2012 14:50'!
addAllThemes: aVersion resourcesDir: aResourcesDir sufixClass: aSufixClass
	| ps basePath baseClass libraryClassBlock |
	ps := GRPlatform current pathSeparator.	
	basePath := 'jquery-ui-themes-', aVersion, ps, 'themes', ps.
	baseClass := Smalltalk at: ('JQBaseTheme', aSufixClass) asSymbol.

	libraryClassBlock := [ :dir | | libraryClass |
		dir = 'base'
			ifTrue: [ libraryClass := baseClass ]
			ifFalse: [
				libraryClass := baseClass
					subclass: ('JQ', (self themeId: dir), aSufixClass) asSymbol
					instanceVariableNames: '' classVariableNames: '' poolDictionaries: ''
					category: 'Webtalk-Libraries-Themes' ].

		GRPlatform current 	compile: 
			(String streamContents: [ :stream | 
				stream nextPutAll: 'themeName';
				nextPut: Character cr;
				nextPut: Character tab;
				nextPutAll: '^ ''';
				nextPutAll: dir;
				nextPutAll: '''' ])
			into: libraryClass classified: 'accessing'.
			
		libraryClass ].

	WTLinkableFileLibrary 
		addAllDirectoriesIn: basePath 
		resourcesDir: aResourcesDir 
		libraryClassBlock: libraryClassBlock! !

!WTJQueryThemesManager class methodsFor: 'as yet unclassified' stamp: 'GastonDallOglio 3/16/2012 14:50'!
linkAllThemes: aBaseThemeClass link: aLink resources: aBaseResourceClass 
	| libraries resourcesLibraries linkedLibraryBlock |

	libraries := 
		(aBaseThemeClass allSubclasses add: aBaseResourceClass; yourself)
			collect: [ :c | c default ].

	resourcesLibraries := 
		(aBaseResourceClass allSubclasses add: aBaseResourceClass; yourself)
			collect: [ :c | c default ].

	linkedLibraryBlock := [ :t |
		^ resourcesLibraries 
			detect: [ :l | l themeName = t themeName ]
			ifNone: [ nil ] ].
	
	WTLinkableFileLibrary
		linkAllLibraries: libraries
		link: aLink
		linkedLibraryBlock: linkedLibraryBlock! !

!WTJQueryThemesManager class methodsFor: 'as yet unclassified' stamp: 'GastonDallOglio 3/16/2012 11:28'!
themeId: dir
	^ (dir copyUpToLast: $-)  asLowercase capitalized,	(dir copyAfterLast: $-) asLowercase capitalized! !

WAFileLibrary subclass: #WTLinkableFileLibrary
	instanceVariableNames: 'links'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Webtalk-Libraries-Core'!

WTLinkableFileLibrary subclass: #JQBaseThemeDeployment
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Webtalk-Libraries-Core'!

!JQBaseThemeDeployment methodsFor: 'accessing' stamp: 'GastonDallOglio 3/16/2012 15:05'!
methodCategory
	"the method category for uploaded files.
	If self is a base class, then an extension method category is returned."
	
	^ self == JQBaseThemeDeployment
		ifTrue: [ '*webtalk-libraries-themes' ]
		ifFalse: [ super methodCategory ]! !

!JQBaseThemeDeployment methodsFor: 'accessing' stamp: 'GastonDallOglio 2/22/2012 11:25'!
selectorsToInclude
	 ^ #(jqueryuiminCss)! !

WTLinkableFileLibrary subclass: #JQBaseThemeDevelopment
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Webtalk-Libraries-Core'!

!JQBaseThemeDevelopment methodsFor: 'accessing' stamp: 'GastonDallOglio 3/16/2012 15:05'!
methodCategory
	"the method category for uploaded files.
	If self is a base class, then an extension method category is returned."
	
	^ self == JQBaseThemeDevelopment
		ifTrue: [ '*webtalk-libraries-themes' ]
		ifFalse: [ super methodCategory ]! !

!JQBaseThemeDevelopment methodsFor: 'accessing' stamp: 'GastonDallOglio 2/22/2012 23:06'!
selectorsToInclude
	^ #(jqueryuiaccordionCss jqueryuiautocompleteCss jqueryuibuttonCss jqueryuicoreCss jqueryuidatepickerCss jqueryuidialogCss jqueryuiprogressbarCss jqueryuiresizableCss jqueryuiselectableCss jqueryuisliderCss jqueryuitabsCss jqueryuithemeCss)! !

WTLinkableFileLibrary subclass: #JQBaseThemeImages
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Webtalk-Libraries-Core'!

!JQBaseThemeImages methodsFor: 'uploaded' stamp: 'GastonDallOglio 3/16/2012 15:06'!
methodCategory
	"the method category for uploaded files.
	If self is a base class, then an extension method category is returned."
	
	^ self == JQBaseThemeImages
		ifTrue: [ '*webtalk-libraries-themes' ]
		ifFalse: [ super methodCategory ]! !

!WTLinkableFileLibrary class methodsFor: 'adding' stamp: 'GastonDallOglio 3/16/2012 10:32'!
addAllDirectoriesIn: aPath resourcesDir: aResourcesDir libraryClassBlock: aLibraryClassBlock
	| ps libraryClass |
	ps := GRPlatform current pathSeparator.	

	(self directoriesIn: aPath) do: [ :dir |
		libraryClass := aLibraryClassBlock value: dir.
				
		libraryClass addAllFilesIn: aPath, ps, dir, ps, aResourcesDir ]! !

!WTLinkableFileLibrary class methodsFor: 'accessing' stamp: 'GastonDallOglio 3/16/2012 09:33'!
directoriesIn: aPathString
	"Return a collection of names for all the subdirectories in the directory given by aPathString
	 must not include file names that start with."

	^ (FileDirectory default directoryNamed: aPathString)
		directoryNames reject: [ :each | each first = $. ]! !

!WTLinkableFileLibrary class methodsFor: 'updating' stamp: 'GastonDallOglio 3/16/2012 11:50'!
linkAllLibraries: aLibraries link: aLink linkedLibraryBlock: aLinkedLibraryBlock
	| linkedLibrary |
	
	aLibraries do: [ :l |
		linkedLibrary := aLinkedLibraryBlock value: l.
	
		linkedLibrary isNil ifFalse: [
			l links at: aLink put: linkedLibrary ] ]! !

!WTLinkableFileLibrary methodsFor: 'handling' stamp: 'GastonDallOglio 3/15/2012 17:53'!
handle: aRequestContext
	"Depending on the size of a path requested, find a WAFileLibrary linked to first element to ask handle remaining path, or directly handle this request. If the WAFileLibrary is not found return self, for that a notFound error is response to the client."
	
	aRequestContext consumer peekToEnd size > 1
		ifTrue: [ | linkedLibrary |
			linkedLibrary := self links at: aRequestContext consumer next
				ifAbsent: [  ^ self ].
		
			linkedLibrary handle: aRequestContext	]
		ifFalse: [
			super handle: aRequestContext  ]! !

!WTLinkableFileLibrary methodsFor: 'accessing' stamp: 'GastonDallOglio 3/15/2012 17:53'!
links
	^ links ifNil: [ links := GRSmallDictionary new ]! !
